import { HttpHandler } from '@smithy/protocol-http';
import { AwsCredentialIdentity } from '@aws-sdk/types';
import { Config } from '../orchestration/Orchestration';
interface OpenIdTokenResponse {
    IdentityId: string;
    Token: string;
}
interface GetIdResponse {
    IdentityId: string;
}
export declare type CognitoIdentityClientConfig = {
    fetchRequestHandler: HttpHandler;
    region?: string;
    clientConfig?: Config;
    applicationId?: string;
};
export declare class CognitoIdentityClient {
    private fetchRequestHandler;
    private hostname;
    private identityStorageKey;
    constructor(config: CognitoIdentityClientConfig);
    getId: (request: {
        IdentityPoolId: string;
    }) => Promise<GetIdResponse>;
    getOpenIdToken: (request: {
        IdentityId: string;
    }) => Promise<OpenIdTokenResponse>;
    getCredentialsForIdentity: (identityId: string) => Promise<AwsCredentialIdentity>;
    private validateOpenIdTokenResponse;
    private validateCredenentialsResponse;
    private getHttpRequest;
}
export {};
