import { AwsCredentialIdentityProvider, AwsCredentialIdentity, HttpResponse, HeaderBag } from '@aws-sdk/types';
import { HttpHandler } from '@smithy/protocol-http';
import { PutRumEventsRequest } from './dataplane';
export declare type DataPlaneClientConfig = {
    fetchRequestHandler: HttpHandler;
    beaconRequestHandler: HttpHandler;
    endpoint: URL;
    region: string;
    credentials: AwsCredentialIdentityProvider | AwsCredentialIdentity | undefined;
    headers?: HeaderBag;
};
export declare class DataPlaneClient {
    private config;
    private awsSigV4;
    constructor(config: DataPlaneClientConfig);
    sendFetch: (putRumEventsRequest: PutRumEventsRequest) => Promise<{
        response: HttpResponse;
    }>;
    sendBeacon: (putRumEventsRequest: PutRumEventsRequest) => Promise<{
        response: HttpResponse;
    }>;
    private getHttpRequestOptions;
}
